#!/usr/bin/perl -T
# $Id: multiplot.cgi,v 1.33 2015/03/09 13:14:07 sofc Exp $
use strict;
use warnings;
use Sys::Hostname;
use Impedance::Header;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use CGI qw(:standard :netscape);
use SemaforeFile;
use File::stat;
use ElchemeaConfig;
my $plotmode = param('plotmode');
$plotmode = 'Nyquist' unless ($plotmode);
my $fitmode = param('fitmode');
$fitmode = 'Inverse' unless ($fitmode);
&print_header("Elchemea Analytical",-onload=>'setTimeout("load_all()",100)');   
top_nav_bar_start();
top_no_button;
top_no_button;
print '<td>';
print button(-name=>'eps',-value=>'save postscript image',-class=>'s3',-onclick=>'save_ps()');
print '</td>';
tab_newrow;
param(-name=>'action',-value=>'') unless (param('action'));
if (param('action'))
{
    js_back();
    top_js_return();
}
else
{
    top_no_button;
}

$_ = param('action');
 CASE:
{
    ### Insert case statements ###
    ### Default response ####
    if ($_ =~ /Load/i)
    {
	&main_form(param('filename'));
    }
    else
    {
	&main_form;
	my $action = '';
	$action = 'setTimeout("set_filelist()",100);' if (param('session'));
	print <<END;
	
<script language="javascript">

function load_all()
{
    $action
}

</script>
END

    }
}
&print_end;
exit;


sub restore_data($)
{
    my $ref = shift;
    my $filename = shift;
    if ($filename && $filename =~ /([\w\.]+)/)
    {
	my $file = ElchemeaConfig->new('/tmp/'.$1);
	foreach my $key ('xmin','xmax','ymin','ymax','title','scale')
	{
	    $$ref{$key} = $file->get_config_value('plot',$key);
	}
	foreach my $key ('labels','style','key','color','mode','admode','user_def')
	{
	    $$ref{$key} = ucfirst($file->get_config_value('plot',$key));
	}
	my $lines = $file->get_config_value('Comments','lines');
	my @ln = ();
	for (my $x = 0; $x < $lines; $x++)
	{
	    push @ln,$file->get_config_value('Comments',$x);
	}
	$$ref{'comments'} = join("\n",@ln);
	my $files = $file->get_config_value('plot','files');
	my @filelist = ();
	my %labels = ();
	for (my $x = 1; $x < $files+1; $x++)
	{
	    my $sec = 'File_'.$x;
	    my $name = $$.'_'.$file->get_config_value($sec,'name').'.data';
	    my $label = $file->get_config_value($sec,'label');
	    my @data = ();
	    my $points = $file->get_config_value($sec,'lines');
	    for (my $y = 0; $y < $points; $y++)
	    {
		push @data,$file->get_config_value($sec,$y);
	    }
	    my $f = SemaforeFile->new('/tmp/'.$name);
	    $f->writeline(@data);
	    push @filelist,$name;
	    $labels{$name} = $label;
	}
	$$ref{'filelist'} = \@filelist;
	$$ref{'filelabels'} = \%labels;
	my $fn = $file->filename();
	unlink $fn if -e ($fn);

	print <<END;
	
<script language="javascript">

function load_all()
{
    setTimeout("set_filelist()",100);
}

</script>
END
    }
    ### Possible cleanum of /tmp ##
}

sub main_form
{
    my %data = (
		'xmin' => '',
		'xmax' => '',
		'ymin' => '',
		'ymax' => '',
		'labels' => 'Top frequencies only',
		'user_def' => '10,500',
		'slabels' => '0',
		'style' => 'lines',
		'key' => 'Key top right',
		'color' => 'Color',
		'mode' => 'Impedance',
		'admode' => 'Impdance',
		'comments' => '',
		'title' => '',
		'src' => "/analytic/elchemeaanalytical.png",
		'filelist' => [],
		'filelabels' => {},
		);
    &restore_data(\%data,@_) if (@_);
    print '<td>';
    print button(-name=>'load',-value=>'Load plot definition',-class=>'s2',-onclick=>'load_plot()');
    print '</td>';
    print '<td>';
    print button(-name=>'save',-value=>'Save plot definition',-class=>'s3',-onclick=>'save_plot()');
    print '</td>';
    top_nav_bar_button('about.cgi','test','About Elchemea Analytic',undef,'s3');
    top_nav_bar_button('main.cgi','test','Fit spectrum',undef,'s6');
    end_top_bar();
    print p();
    print '<table width=100% class=table><tr>';
    print '<td width=5%></td>';
    print '<td width=30%></th>';
    print '<td width=60%></td>';
    print '<td width=5%></td></tr>';
    print start_form(-name=>'control');
    print '<tr><td></td><td>';
    ### File list and controls here
    print '<table width=100% class="table" cellspacing=10>';
    print '<tr><td width=50% rowspan=12 valign=top>';

    print '<table width=100% class="table">';
    print '<tr><td colspan=2 width=100% valign=top>';
    print h3('File list');
    my @users = ();
    my %userlabel = ();
    my $system = '';
    my $dir = '/home/http/html/';
    if (-d $dir)
    {
	$system = 'RFCcontrol';
	opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	@users = grep {/rig\d+/} readdir MYDIR;
	closedir MYDIR;
	%userlabel = ('' => 'Rig name:');
    }
    $dir = '/home/elchemea/users/';
    if (-d $dir)
    {
	$system = 'Elchemea';
	opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
	@users = grep {/\w+/} readdir MYDIR;
	closedir MYDIR;
	%userlabel = ('' => 'User name:');
    }
    unshift @users,'';
    if (param('session') && $system eq 'RFCcontrol' && !@_)
    {
        my @files = ();
	my $id = get_CGI_value_clean('id');
	my %lb = ();
	my $user = get_CGI_value_clean('user');
	my $session = get_CGI_value_clean('session');
        my $dir = '/home/http/html/'.$user.'/'.$session.'/impedance/';
        if (-d $dir)
        {
            opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
            @files = sort imp_sort grep {/\.i2b$/} readdir MYDIR;
            closedir MYDIR;
        }
	my @flist = ();
	foreach (@files)
	{
	    push @flist,$id.'_'.$_.'.data';
	    $lb{$id.'_'.$_.'.data'} = $_;
	}
	print scrolling_list(-name=>'filelist',-values=>[@flist],-labels=>\%lb,-size=>27,-multiple=>'true',-class=>'textfield',-onchange=>'set_filelist()',-onDblClick=>'change_legend(this.selectedIndex)',-onkeydown=>'change_order(event)');
    }
    else
    {
	print scrolling_list(-name=>'filelist',-values=>[@{$data{'filelist'}}],-labels=>$data{'filelabels'},-size=>27,-multiple=>'true',-class=>'textfield',-onchange=>'set_filelist()',-onDblClick=>'change_legend(this.selectedIndex)',-default=>[@{$data{'filelist'}}],-onkeydown=>'change_order(event)');
    }
    print '</td></tr><td width=50%>';
    print popup_menu(-name=>'user',-onchange=>'set_user(this.value,"'.$system.'")',-values=>[@users],-class=>'textfield',-default=>param('user'),-labels=>\%userlabel);
    print '</td><td width=50%>';
    if (param('session') && $system eq 'RFCcontrol')
    {
        my @sessions = ();
	my $user = get_CGI_value_clean('user');
        my $dir = '/home/http/html/'.$user.'/';
        if (-d $dir)
        {
            opendir (MYDIR,$dir) or die "Could not open directory $dir $!\n";
            @sessions = grep {/\d+test\d+/i} readdir MYDIR;
            closedir MYDIR;
            my %ses = ();
            foreach (@sessions)
            {
                /(\d+)$/;
                $ses{$1} = $_;
            }
            @sessions = ();
            foreach my $key (sort {$a <=> $b} keys %ses)
            {
                push @sessions,$ses{$key};
            }
        }
	print popup_menu(-name=>'session',-values=>[@sessions],-default=>param('session'),-force=>1,-class=>'textfield',-onchange=>"select_session(this.value,'$system')");
    }
    else
    {
	print popup_menu(-name=>'session',-values=>[''],-default=>'',-class=>'textfield',-onchange=>"select_session(this.value,'$system')");
    }
    if ($system eq 'RFCcontrol')
    {
	print '</td></tr><tr><tr><td>';
	print button(-name=>'test1',-value=>"Load local \n file",-class=>'s3',-style=>'height:40px;',-onclick=>"CPLE_open('load_i2b.cgi',400,300,30,30)");
	print '</td><td>';
	print button(-name=>'test2',-value=>"Load file \n from cluster",-class=>'s3',-style=>'height:40px;',-onclick=>"CPLE_open('load_cluster.cgi',400,300,30,30)");
    }
    else
    {
	print '</td></tr><tr><tr><td colspan=2>';
	print button(-name=>'Load local file',-class=>'s3',-onclick=>"CPLE_open('load_i2b.cgi',400,300,30,30)");
    }
    print '</td></tr></table>';
    print '</td><td colspan=2 valign=top>';
    print h3('Plot control');
    print '</td></tr>';
    print '<tr></td><td width=25%>';
    print popup_menu(-name=>'style',-values=>['Lines','Points','Linespoints'],-default=>$data{'style'},-force=>1,-class=>'textfield',-onchange=>'set_filelist()');
    print '</td><td width=25%>';
    print popup_menu(-name=>'mode',-values=>['Nyquist','Bode','bode (imag only)'],-default=>$data{'mode'},-force=>1,-class=>'textfield',-onchange=>'set_mode(this.value)');
    print '</td></tr>';
    print '<tr><td>';
    print popup_menu(-name=>'color',-values=>['Color','Monochrome'],-default=>$data{'color'},-force=>1,-class=>'textfield',-onchange=>'set_filelist()');
    print '</td><td>';
    print popup_menu(-name=>'key',-values=>['Key top right','Key top left','Key bottom right','Key bottom left','No key'],-default=>$data{'key'},-force=>1,-class=>'textfield',-onchange=>'set_mode(this.value)');
    print '</td></tr>';
    print '<tr><td> Frequency labels </td><td>';
    my %labels = (1=>2,2=>3,3=>4,4=>5,5=>6);
    print popup_menu(-name=>'labels',-values=>['None','1','2','3','4','5','Decades','Top frequencies only','User defined'],-labels=>\%labels,-default=>$data{'labels'},-force=>1,-class=>'textfield',-onchange=>'set_label(this.value)');
    print '</td></tr>';
    print '<tr><td></td><td>';
    my $class = 'texthidden';
    $class = 'textfield' if (param('labels') && param('labels') =~ /defined/i);
    print textfield(-id=>'user_def',-name=>'user_def',-class=>$class,-value=>$data{'user_def'},-onchange=>'set_filelist()');
    print '</td></tr>';
    print '<tr><td> Scale </td><td>';
    my %slabels = (-3=>'mOhm',0=>'Ohm',3=>'kOhm',6=>'MOhm');
    print popup_menu(-name=>'scale',-values=>[-3,0,3,6],-labels=>\%slabels,-default=>$data{'slabels'},-force=>1,-class=>'textfield',-onchange=>'set_scale(this.value)');
    print '</td></tr>';
    print '<tr><td> Title </td><td>';
    print textfield(-name=>'title',-onchange=>'set_title()',-class=>'textfield',-value=>$data{'title'},-force=>1);
    print '</td></tr>';
    print '<tr><td> Plane </td><td>';
    my $m = Impedance::Model->new();
    print popup_menu(-name=>'admode',-values=>[$m->admittance_mode_values()],-default=>$data{'admode'},-force=>1,-class=>'textfield',-onchange=>'set_admode(this.value)');
    print '</td></tr>';

    print '<tr><td colspan=2><h3 id="range"> Plot range </h3></td></tr>';
    print '<tr><td> X min:';
    print textfield(-name=>'xmin',-onchange=>'set_xmin()',-class=>'textfield',-value=>$data{'xmin'},-force=>1);
    print '</td><td> X max:';
    print textfield(-name=>'xmax',-onchange=>'set_xmax()',-class=>'textfield',-value=>$data{'xmax'},-force=>1);
    print '</td></tr>';
    print '<tr><td> Y min:';
    print textfield(-name=>'ymin',-onchange=>'set_ymin()',-class=>'textfield',-value=>$data{'ymin'},-force=>1);
    print '</td><td> Y max:';
    print textfield(-name=>'ymax',-onchange=>'set_ymax()',-class=>'textfield',-value=>$data{'ymax'},-force=>1);
    print '</td></tr>';
    print '<tr><td colspan=2> Additional Gnuplot commands';
    print textarea(-name=>'comments',-value=>$data{'comments'},-force=>1,-class=>'textfield',-rows=>5,-onchange=>'set_filelist()');
    print '</td></tr>';
    print '</table>';
    print end_form();
    print '</td><td>';
    print '<img name="plot" src="'.$data{'src'}.'" id="plot">';
    print '</td></tr></table>';
    print start_form(-name=>'load');
    &action('Load');
    print hidden(-name=>'filename',-value=>'',-force=>1);
    print end_form();
    &print_js_manipulate($system);
}

sub imp_sort
{
    return ($a <=> $b) unless ($a && $a =~ /s\d+_\d+\w*?\.i2b/ && $b && $b =~ /s\d+_\d+\w*?\.i2b/);
    $a =~ /s\d+_(\d+)\w*?\.i2b/;
    my $left = $1;
    $b =~ /s\d+_(\d+)\w*?\.i2b/;
    my $right = $1;
    return $left <=> $right;
}


sub print_js_manipulate($)
{
    my $id = $$;
    my $system = shift;
    print <<END;

<script language="javascript">

var imgok = false;

function set_list(res)
{
    var arr =  res.split("\\n");
    if (arr[0] != "OK")
    {
        alert(res);
        return false;
    }
    var element = document.control.filelist;
    element.length = 0;
    for (x = 1; x < arr.length; x++)
    {
	var newOption = document.createElement('option');
	newOption.value='$id'+'_'+arr[x]+'.data';
	newOption.text=arr[x];
	element.options.add(newOption);	
    }
}

function select_session(session,sys)
{
    var user = document.control.user.value;
    run_ajax('ajax_multi.cgi',"&action=set_session&user="+user+"&system="+sys+"&session="+session,set_list);
}

function set_session(res)
{
    var arr =  res.split("\\n");
    if (arr[0] != "OK")
    {
        alert(res);
        return false;
    }
    document.control.filelist.length = 0;
    var element = document.control.session;
    element.length = 0;
    for (x = 1; x < arr.length; x++)
    {
	var ar1 = arr[x].split(":");
	var newOption = document.createElement('option');
	newOption.value=ar1[0];
	newOption.text=ar1[1];
	element.options.add(newOption);	
    }
}

function set_user(user,sys)
{
    run_ajax('ajax_multi.cgi',"&action=load_session&user="+user+"&system="+sys,set_session);
}

function save_plot()
{
    var q = get_querystr();
    report_open('ajax_multi.cgi?action=save&ajax=1'+q,600,500,30,30);
}

function load_plot()
{
    report_open('load_multi.cgi',600,500,30,30);
}

function change_legend(id)
{
    var name = document.control.filelist[id].value;
    var newtext = prompt("Input new label for file '"+name+"'",document.control.filelist[id].text);
    if (newtext == null)
    {
	return false;
    }
    if (newtext =="" || newtext == " ")
    {
	document.control.filelist[id].text = document.control.filelist[id].value;
    }
    else
    {
	document.control.filelist[id].text = newtext;
    }
    set_filelist();
}

function set_title(r)
{
    set_filelist();
}

function set_scale(r)
{
    set_filelist();
}

function set_admode(r)
{
    set_filelist();
}

function set_label(r)
{
    var e = document.getElementById('user_def');
    if (r == 'User defined')
    {
	e.setAttribute("class","textfield");
    }
    else
    {
	e.setAttribute("class","texthidden");
    }
    set_filelist();
}

function set_xmin()
{
    set_filelist();
}

function set_xmax()
{
    set_filelist();
}

function set_ymin()
{
    set_filelist();
}

function set_ymax()
{
    set_filelist();
}

function set_mode(m)
{
    set_filelist();
}

function set_image(res)
{
    var arr =  res.split("\\n");
    if (arr[0] != "OK")
    {
        alert(res);
        return false;
    }
    var img = document.getElementById("plot");
    img.src = '/analytic/png/' + arr[1] + "?" + Math.random();
    imgok = true;
}

function save_ps()
{
    if (imgok == false)
    {
	return false;
    }
    var img = document.getElementById("plot");
    var src = img.src;
    src = src.replace(/\\.png/,".ps");
    report_open(src,600,500,30,30);
}

function get_querystr()
{
    var reg = /[\\#\\:]/;
    var form = document.control;
    var list = form.filelist;
    var selectarr = [];
    for (var i = 0; i < list.length; i++)
    {
	if (list.options[i].selected == true)
	{
            if (reg.test(list.options[i].value+list.options[i].text))
            {
		alert("':' or '#' is not allowed in filenames or file text!");
		return false;
            }
	    selectarr.push(list.options[i].value+':'+list.options[i].text);
	}
    }
    var s = form.style;
    var m = form.mode;
    var xmin = form.xmin.value;
    var xmax = form.xmax.value;
    var ymin = form.ymin.value;
    var ymax = form.ymax.value;
    var labels = form.labels.value;
    var user_def = form.user_def.value;
    var color = form.color.value;
    var key = form.key.value;
    var comm = form.comments.value;
    var session = form.session.value;
    var scale = form.scale.value;
    var title = form.title.value;
    var admode = form.admode.value;
    var user = form.user.value;
    var q = "&filenames="+selectarr.join(',')+"&session=$id&style="+s.value+"&mode="+m.value+"&xmin="+xmin+"&xmax="+xmax+"&ymin="+ymin+"&ymax="+ymax+"&labels="+labels+"&user_def="+user_def+"&color="+color+"&key="+key+"&comm="+comm+"&usersession="+session+"&user="+user+"&system=$system"+"&scale="+scale+"&title="+title+"&admode="+admode;
    q = q.replace(/\\n/g,"%0A");
    q = q.replace(/\\+/g,"%2B");
    return q;
}

function set_filelist()
{
    var q = get_querystr();
    if (q === false)
    {
	return false;
    }
    run_ajax('ajax_multi.cgi',"&action=plot"+q,set_image);
}

function load_file()
{
    var q = "&action=save_file&filename="+document.sofc.filename.value+"&data="+document.sofc.data.value+"&session=$id";
    q = q.replace(/\\n/g,"%0A");
    q = q.replace(/\\+/g,"%2B");
    q = q.replace(/\\t/g,',');
    run_ajax('ajax_multi.cgi',q,add_file);
}

function add_file(res)
{
    var arr =  res.split("\\n");
    if (arr[0] != "OK")
    {
        alert(res);
        return false;
    }
    var element = document.control.filelist;
    var newOption = document.createElement('option');
    newOption.value=arr[1];
    newOption.text=arr[2];
    element.options.add(newOption);
    element.options[element.length-1].selected = true;
    set_filelist();
}

function sofc_submit()
{
    load_file();
}


function change_order(event)
{
    var element = document.control.filelist;
    if (element.length < 2)
    {
	return false;
    }
    var x = element.selectedIndex;
    var keyCode = ('which' in event) ? event.which : event.keyCode;
    if (keyCode == 85)
    {
	/* Up */
	if (x == 0)
	    return false;
	var newOption = document.createElement('option');
	newOption.value = element.options[x-1].value;
	newOption.text = element.options[x-1].text;
	element.options[x-1].text = element.options[x].text;
	element.options[x-1].value = element.options[x].value;
	element.options[x].value = newOption.value;
	element.options[x].text = newOption.text;
	element.options[x-1].selected = true;
	element.options[x].selected = false;
    }
    if (keyCode == 68)
    {
	/* Down */
	if (x == element.length-1)
	    return false;
	var newOption = document.createElement('option');
	newOption.value = element.options[x+1].value;
	newOption.text = element.options[x+1].text;
	element.options[x+1].text = element.options[x].text;
	element.options[x+1].value = element.options[x].value;
	element.options[x].value = newOption.value;
	element.options[x].text = newOption.text;
	element.options[x+1].selected = true;
	element.options[x].selected = false;
    }
}


</script>


END

}
